{%- from "cinder/map.jinja" import client with context %}
{%- if client.get('enabled', False) %}

cinder_client_packages:
  pkg.installed:
  - names: {{ client.pkgs }}

{%- for backend_name, backend in client.get('backend', {}).items() %}

cinder_type_create_{{ backend_name }}:
  cinderv3.volume_type_present:
  - name: {{ backend.type_name }}
  - cloud_name: admin_identity
  {%- if client.connection_params is defined %}
  - connection_params:  {{ client.connection_params }}
  {%- endif %}
  - require:
    - pkg: cinder_client_packages

cinder_type_update_{{ backend_name }}:
  cinderv3.volume_type_key_present:
  - name: {{ backend.type_name }}
  - key: volume_backend_name
  - value: {{ backend_name }}
  - cloud_name: admin_identity
  {%- if client.connection_params is defined %}
  - connection_params:  {{ client.connection_params }}
  {%- endif %}
  - require:
    - cinderv3: cinder_type_create_{{ backend_name }}

{%- for key_name, key_value in backend.get('key', {}).items() %}

cinder_type_update_{{ backend_name }}_{{ key_name }}:
  cinderv3.volume_type_key_present:
  - name: {{ backend.type_name }}
  - key: {{ key_name }}
  - value: {{ key_value }}
  - cloud_name: admin_identity
  {%- if client.connection_params is defined %}
  - connection_params:  {{ client.connection_params }}
  {%- endif %}
  - require:
    - cinderv3: cinder_type_create_{{ backend_name }}

{%- endfor %}

{%- endfor %}

{%- endif %}
